AOMedia AV1 Codec: FeatureFlags Struct Reference

| AOMedia AV1 Codec

Data Fields
FeatureFlags Struct Reference

Frame level features. More...

`#include <av1_common_int.h>`

## Data Fields
bool | disable_cdf_update
bool | allow_high_precision_mv
bool | cur_frame_force_integer_mv
bool | allow_screen_content_tools
bool | allow_intrabc
bool | allow_warped_motion
bool | allow_ref_frame_mvs
bool | coded_lossless
bool | all_lossless
bool | reduced_tx_set_used
bool | error_resilient_mode
bool | switchable_motion_mode
TX_MODE | tx_mode
InterpFilter | interp_filter
int | primary_ref_frame
int | byte_alignment
REFRESH_FRAME_CONTEXT_MODE | refresh_frame_context

## Detailed Description

Frame level features.

## Field Documentation

## ◆ disable_cdf_update

bool FeatureFlags::disable_cdf_update

If true, CDF update in the symbol encoding/decoding process is disabled.

Referenced by encode_frame_to_data_rate().

## ◆ allow_high_precision_mv

bool FeatureFlags::allow_high_precision_mv

If true, motion vectors are specified to eighth pel precision; and if false, motion vectors are specified to quarter pel precision.

Referenced by encode_with_recode_loop(), and find_predictors().

## ◆ cur_frame_force_integer_mv

bool FeatureFlags::cur_frame_force_integer_mv

If true, force integer motion vectors; if false, use the default.

Referenced by encode_frame_to_data_rate(), encode_sb_row(), and tf_motion_search().

## ◆ allow_screen_content_tools

bool FeatureFlags::allow_screen_content_tools

If true, palette tool and/or intra block copy tools may be used.

Referenced by av1_nonrd_pick_intra_mode(), av1_rd_pick_inter_mode(), av1_rd_pick_intra_sbuv_mode(), av1_rd_pick_intra_sby_mode(), av1_search_intra_uv_modes_in_interframe(), encode_frame_to_data_rate(), intra_mode_info_cost_uv(), and intra_mode_info_cost_y().

## ◆ allow_intrabc

bool FeatureFlags::allow_intrabc

If true, intra block copy tool may be used.

Referenced by encode_frame_internal(), and encode_with_recode_loop_and_filter().

## ◆ allow_warped_motion

bool FeatureFlags::allow_warped_motion

If true, frame may use warped motion mode.

Referenced by av1_encode_frame(), encode_b(), encode_frame_internal(), encode_frame_to_data_rate(), and motion_mode_rd().

## ◆ allow_ref_frame_mvs

bool FeatureFlags::allow_ref_frame_mvs

If true, using previous frames' motion vectors for prediction is allowed.

Referenced by encode_frame_internal(), and encode_frame_to_data_rate().

## ◆ coded_lossless

bool FeatureFlags::coded_lossless

If true, frame is fully lossless at coded resolution.

Referenced by encode_frame_internal(), and loopfilter_frame().

## ◆ all_lossless

bool FeatureFlags::all_lossless

If true, frame is fully lossless at upscaled resolution.

Referenced by encode_frame_internal(), and loopfilter_frame().

## ◆ reduced_tx_set_used

bool FeatureFlags::reduced_tx_set_used

If true, the frame is restricted to a reduced subset of the full set of transform types.

Referenced by av1_encode_frame().

## ◆ error_resilient_mode

bool FeatureFlags::error_resilient_mode

If true, error resilient mode is enabled. Note: Error resilient mode allows the syntax of a frame to be parsed independently of previously decoded frames.

Referenced by av1_encode(), and encode_without_recode().

## ◆ switchable_motion_mode

bool FeatureFlags::switchable_motion_mode

If false, only MOTION_MODE that may be used is SIMPLE_TRANSLATION; if true, all MOTION_MODES may be used.

Referenced by av1_encode_frame(), encode_b(), find_predictors(), and motion_mode_rd().

## ◆ tx_mode

TX_MODE FeatureFlags::tx_mode

Transform mode at frame level.

Referenced by av1_encode_frame(), and encode_frame_internal().

## ◆ interp_filter

InterpFilter FeatureFlags::interp_filter

Interpolation filter at frame level.

Referenced by av1_encode_frame(), av1_interpolation_filter_search(), av1_rd_pick_inter_mode(), encode_frame_internal(), fast_interp_search(), motion_mode_rd(), process_compound_inter_mode(), and search_filter_ref().

## ◆ primary_ref_frame

int FeatureFlags::primary_ref_frame

The reference frame that contains the CDF values and other state that should be loaded at the start of the frame.

Referenced by av1_encode(), and encode_without_recode().

## ◆ byte_alignment

int FeatureFlags::byte_alignment

Byte alignment of the planes in the reference buffers.

Referenced by encode_without_recode().

## ◆ refresh_frame_context

REFRESH_FRAME_CONTEXT_MODE FeatureFlags::refresh_frame_context

Flag signaling how frame contexts should be updated at the end of a frame decode.

Referenced by av1_get_compressed_data(), and encode_frame_to_data_rate().

The documentation for this struct was generated from the following file:

- av1/common/av1_common_int.h